Создает или обновляет ключ сервера.
PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Sql/servers/{serverName}/keys/{keyName}?api-version=2025-01-01
Параметры URI
| Имя |
В |
Обязательно |
Тип |
Описание |
|
keyName
|
path |
True
|
string
|
Имя извлекаемого ключа сервера.
|
|
resourceGroupName
|
path |
True
|
string
minLength: 1 maxLength: 90
|
Имя группы ресурсов. Имя регистронезависимо.
|
|
serverName
|
path |
True
|
string
|
Имени сервера.
|
|
subscriptionId
|
path |
True
|
string
(uuid)
|
Идентификатор целевой подписки. Значение должно быть Универсальным Уникальным Идентификатором (UUID).
|
|
api-version
|
query |
True
|
string
minLength: 1
|
Версия API, используемая для данной операции.
|
Текст запроса
| Имя |
Обязательно |
Тип |
Описание |
|
properties.serverKeyType
|
True
|
ServerKeyType
|
Тип ключа сервера, например ServiceManaged, AzureKeyVault.
|
|
properties.uri
|
|
string
|
Универсальный код ресурса (URI) ключа сервера. Если сервер ServerKeyType является AzureKeyVault, то требуется универсальный код ресурса (URI). URI AKV должен быть в следующем формате: 'https://YourVaultName.vault.azure.net/keys/YourKeyName/YourKeyVersion' или может быть 'https://YourVaultName.vault.azure.net/keys/YourKeyName'
|
Ответы
| Имя |
Тип |
Описание |
|
200 OK
|
ServerKey
|
Операция обновления ресурса 'ServerKey' была успешна
|
|
201 Created
|
ServerKey
|
Операция создания ресурса 'ServerKey' успешно выполнена
Заголовки
- Location: string
- Retry-After: integer
|
|
202 Accepted
|
|
Операция ресурса принята.
Заголовки
- Location: string
- Retry-After: integer
|
|
Other Status Codes
|
ErrorResponse
|
Непредвиденное сообщение об ошибке.
|
Безопасность
azure_auth
Azure Active Directory OAuth2 Flow.
Тип:
oauth2
Flow:
implicit
URL-адрес авторизации:
https://login.microsoftonline.com/common/oauth2/authorize
Области
| Имя |
Описание |
|
user_impersonation
|
олицетворения учетной записи пользователя
|
Примеры
Creates or updates a server key
Образец запроса
PUT https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901?api-version=2025-01-01
{
"properties": {
"serverKeyType": "AzureKeyVault",
"uri": "https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901"
}
}
import com.azure.resourcemanager.sql.fluent.models.ServerKeyInner;
import com.azure.resourcemanager.sql.models.ServerKeyType;
/**
* Samples for ServerKeys CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdate.json
*/
/**
* Sample code: Creates or updates a server key.
*
* @param manager Entry point to SqlServerManager.
*/
public static void createsOrUpdatesAServerKey(com.azure.resourcemanager.sql.SqlServerManager manager) {
manager.serviceClient().getServerKeys().createOrUpdate("sqlcrudtest-7398", "sqlcrudtest-4645",
"someVault_someKey_01234567890123456789012345678901",
new ServerKeyInner().withServerKeyType(ServerKeyType.AZURE_KEY_VAULT)
.withUri("https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901"),
com.azure.core.util.Context.NONE);
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.sql import SqlManagementClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-sql
# USAGE
python server_key_create_or_update.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = SqlManagementClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.server_keys.begin_create_or_update(
resource_group_name="sqlcrudtest-7398",
server_name="sqlcrudtest-4645",
key_name="someVault_someKey_01234567890123456789012345678901",
parameters={
"properties": {
"serverKeyType": "AzureKeyVault",
"uri": "https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901",
}
},
).result()
print(response)
# x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdate.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { SqlManagementClient } = require("@azure/arm-sql");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a server key.
*
* @summary creates or updates a server key.
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdate.json
*/
async function createsOrUpdatesAServerKey() {
const credential = new DefaultAzureCredential();
const subscriptionId = "00000000-1111-2222-3333-444444444444";
const client = new SqlManagementClient(credential, subscriptionId);
const result = await client.serverKeys.createOrUpdate(
"sqlcrudtest-7398",
"sqlcrudtest-4645",
"someVault_someKey_01234567890123456789012345678901",
{
serverKeyType: "AzureKeyVault",
uri: "https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901",
},
);
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
using Azure;
using Azure.ResourceManager;
using System;
using System.Threading.Tasks;
using Azure.Core;
using Azure.Identity;
using Azure.ResourceManager.Sql.Models;
using Azure.ResourceManager.Sql;
// Generated from example definition: specification/sql/resource-manager/Microsoft.Sql/SQL/stable/2025-01-01/examples/ServerKeyCreateOrUpdate.json
// this example is just showing the usage of "ServerKeys_CreateOrUpdate" operation, for the dependent resources, they will have to be created separately.
// get your azure access token, for more details of how Azure SDK get your access token, please refer to https://learn.microsoft.com/en-us/dotnet/azure/sdk/authentication?tabs=command-line
TokenCredential cred = new DefaultAzureCredential();
// authenticate your client
ArmClient client = new ArmClient(cred);
// this example assumes you already have this SqlServerResource created on azure
// for more information of creating SqlServerResource, please refer to the document of SqlServerResource
string subscriptionId = "00000000-1111-2222-3333-444444444444";
string resourceGroupName = "sqlcrudtest-7398";
string serverName = "sqlcrudtest-4645";
ResourceIdentifier sqlServerResourceId = SqlServerResource.CreateResourceIdentifier(subscriptionId, resourceGroupName, serverName);
SqlServerResource sqlServer = client.GetSqlServerResource(sqlServerResourceId);
// get the collection of this SqlServerKeyResource
SqlServerKeyCollection collection = sqlServer.GetSqlServerKeys();
// invoke the operation
string keyName = "someVault_someKey_01234567890123456789012345678901";
SqlServerKeyData data = new SqlServerKeyData
{
ServerKeyType = SqlServerKeyType.AzureKeyVault,
Uri = new Uri("https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901"),
};
ArmOperation<SqlServerKeyResource> lro = await collection.CreateOrUpdateAsync(WaitUntil.Completed, keyName, data);
SqlServerKeyResource result = lro.Value;
// the variable result is a resource, you could call other operations on this instance as well
// but just for demo, we get its data from this resource instance
SqlServerKeyData resourceData = result.Data;
// for demo we just print out the id
Console.WriteLine($"Succeeded on id: {resourceData.Id}");
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Пример ответа
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
Creates or updates a server key with versionless key
Образец запроса
PUT https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey?api-version=2025-01-01
{
"properties": {
"serverKeyType": "AzureKeyVault",
"uri": "https://someVault.vault.azure.net/keys/someKey"
}
}
import com.azure.resourcemanager.sql.fluent.models.ServerKeyInner;
import com.azure.resourcemanager.sql.models.ServerKeyType;
/**
* Samples for ServerKeys CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdateWithVersionlessKey.json
*/
/**
* Sample code: Creates or updates a server key with versionless key.
*
* @param manager Entry point to SqlServerManager.
*/
public static void
createsOrUpdatesAServerKeyWithVersionlessKey(com.azure.resourcemanager.sql.SqlServerManager manager) {
manager.serviceClient().getServerKeys().createOrUpdate("sqlcrudtest-7398", "sqlcrudtest-4645",
"someVault_someKey", new ServerKeyInner().withServerKeyType(ServerKeyType.AZURE_KEY_VAULT)
.withUri("https://someVault.vault.azure.net/keys/someKey"),
com.azure.core.util.Context.NONE);
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.sql import SqlManagementClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-sql
# USAGE
python server_key_create_or_update_with_versionless_key.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = SqlManagementClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.server_keys.begin_create_or_update(
resource_group_name="sqlcrudtest-7398",
server_name="sqlcrudtest-4645",
key_name="someVault_someKey",
parameters={
"properties": {"serverKeyType": "AzureKeyVault", "uri": "https://someVault.vault.azure.net/keys/someKey"}
},
).result()
print(response)
# x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdateWithVersionlessKey.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { SqlManagementClient } = require("@azure/arm-sql");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a server key.
*
* @summary creates or updates a server key.
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdateWithVersionlessKey.json
*/
async function createsOrUpdatesAServerKeyWithVersionlessKey() {
const credential = new DefaultAzureCredential();
const subscriptionId = "00000000-1111-2222-3333-444444444444";
const client = new SqlManagementClient(credential, subscriptionId);
const result = await client.serverKeys.createOrUpdate(
"sqlcrudtest-7398",
"sqlcrudtest-4645",
"someVault_someKey",
{ serverKeyType: "AzureKeyVault", uri: "https://someVault.vault.azure.net/keys/someKey" },
);
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
using Azure;
using Azure.ResourceManager;
using System;
using System.Threading.Tasks;
using Azure.Core;
using Azure.Identity;
using Azure.ResourceManager.Sql.Models;
using Azure.ResourceManager.Sql;
// Generated from example definition: specification/sql/resource-manager/Microsoft.Sql/SQL/stable/2025-01-01/examples/ServerKeyCreateOrUpdateWithVersionlessKey.json
// this example is just showing the usage of "ServerKeys_CreateOrUpdate" operation, for the dependent resources, they will have to be created separately.
// get your azure access token, for more details of how Azure SDK get your access token, please refer to https://learn.microsoft.com/en-us/dotnet/azure/sdk/authentication?tabs=command-line
TokenCredential cred = new DefaultAzureCredential();
// authenticate your client
ArmClient client = new ArmClient(cred);
// this example assumes you already have this SqlServerResource created on azure
// for more information of creating SqlServerResource, please refer to the document of SqlServerResource
string subscriptionId = "00000000-1111-2222-3333-444444444444";
string resourceGroupName = "sqlcrudtest-7398";
string serverName = "sqlcrudtest-4645";
ResourceIdentifier sqlServerResourceId = SqlServerResource.CreateResourceIdentifier(subscriptionId, resourceGroupName, serverName);
SqlServerResource sqlServer = client.GetSqlServerResource(sqlServerResourceId);
// get the collection of this SqlServerKeyResource
SqlServerKeyCollection collection = sqlServer.GetSqlServerKeys();
// invoke the operation
string keyName = "someVault_someKey";
SqlServerKeyData data = new SqlServerKeyData
{
ServerKeyType = SqlServerKeyType.AzureKeyVault,
Uri = new Uri("https://someVault.vault.azure.net/keys/someKey"),
};
ArmOperation<SqlServerKeyResource> lro = await collection.CreateOrUpdateAsync(WaitUntil.Completed, keyName, data);
SqlServerKeyResource result = lro.Value;
// the variable result is a resource, you could call other operations on this instance as well
// but just for demo, we get its data from this resource instance
SqlServerKeyData resourceData = result.Data;
// for demo we just print out the id
Console.WriteLine($"Succeeded on id: {resourceData.Id}");
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Пример ответа
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
Определения
createdByType
Перечисление
Тип удостоверения, создавшего ресурс.
| Значение |
Описание |
|
User
|
|
|
Application
|
|
|
ManagedIdentity
|
|
|
Key
|
|
ErrorAdditionalInfo
Объект
Ошибка управления ресурсами дополнительная информация.
| Имя |
Тип |
Описание |
|
info
|
object
|
Дополнительная информация.
|
|
type
|
string
|
Тип дополнительной информации.
|
ErrorDetail
Объект
Детали ошибки.
| Имя |
Тип |
Описание |
|
additionalInfo
|
ErrorAdditionalInfo[]
|
Ошибка дополнительная информация.
|
|
code
|
string
|
Код ошибки.
|
|
details
|
ErrorDetail[]
|
Сведения об ошибке.
|
|
message
|
string
|
Сообщение об ошибке.
|
|
target
|
string
|
Целевой объект ошибки.
|
ErrorResponse
Объект
Ответ на ошибку
ServerKey
Объект
Ключ сервера.
| Имя |
Тип |
Описание |
|
id
|
string
(arm-id)
|
Полный идентификатор ресурса для ресурса. Например, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
|
|
kind
|
string
|
Тип защиты шифрования. Это метаданные, используемые для работы с порталом Azure.
|
|
location
|
string
|
Расположение ресурса.
|
|
name
|
string
|
Имя ресурса
|
|
properties.autoRotationEnabled
|
boolean
|
Флаг автоматического поворота клавиши. Значение true или false.
|
|
properties.creationDate
|
string
(date-time)
|
Дата создания ключа сервера.
|
|
properties.keyVersion
|
string
|
Версия ключа сервера.
|
|
properties.serverKeyType
|
ServerKeyType
|
Тип ключа сервера, например ServiceManaged, AzureKeyVault.
|
|
properties.subregion
|
string
|
Поверх ключа сервера.
|
|
properties.thumbprint
|
string
|
Отпечаток ключа сервера.
|
|
properties.uri
|
string
|
Универсальный код ресурса (URI) ключа сервера. Если сервер ServerKeyType является AzureKeyVault, то требуется универсальный код ресурса (URI). URI AKV должен быть в следующем формате: 'https://YourVaultName.vault.azure.net/keys/YourKeyName/YourKeyVersion' или может быть 'https://YourVaultName.vault.azure.net/keys/YourKeyName'
|
|
systemData
|
systemData
|
Azure Resource Manager метаданные, содержащие информацию createdBy и modifiedBy.
|
|
type
|
string
|
Тип ресурса. Например, «Майкрософт. Compute/virtualMachines» или «Майкрософт. Аккаунты хранения/хранения»
|
ServerKeyType
Перечисление
Тип защиты шифрования, например ServiceManaged, AzureKeyVault.
| Значение |
Описание |
|
ServiceManaged
|
Управление сервисом
|
|
AzureKeyVault
|
AzureKeyVault
|
systemData
Объект
Метаданные, относящиеся к созданию и последнему изменении ресурса.
| Имя |
Тип |
Описание |
|
createdAt
|
string
(date-time)
|
Метка времени создания ресурса (UTC).
|
|
createdBy
|
string
|
Удостоверение, создающее ресурс.
|
|
createdByType
|
createdByType
|
Тип удостоверения, создавшего ресурс.
|
|
lastModifiedAt
|
string
(date-time)
|
Временная метка последнего изменения ресурса (UTC)
|
|
lastModifiedBy
|
string
|
Идентификатор, который последний раз изменил ресурс.
|
|
lastModifiedByType
|
createdByType
|
Тип удостоверения, который последний раз изменил ресурс.
|